Code

Fixed typo
[gosa.git] / gosa-core / dh-make-gosa
1 #!/bin/bash
3 usage() {
4   echo "Usage: ${0##*/} [--download] [-b|--branch branch] [-e|--email mail] [--depends] plugin-dir|plugin.tar.gz" >&2
5   exit 1
6 }
9 load_dsc() {
10   if [ -r "$1" ]; then
11     PL_NAME=$(sed -n 's/"//g;s/^name\s*=\s*\(.*\)$/\1/p' "$1")
12     PL_VERSION=$(sed -n 's/"//g;s/^version\s*=\s*\(.*\)$/\1/p' "$1")
13     TDEPENDS=$(sed -n 's/"//g;s/^depends\s*=\s*\(.*\)$/\1/p' "$1")
14     for dep in $TDEPENDS; do
15       PL_DEPENDS="gosa-plugin-$dep, $PL_DEPENDS"
16     done
17     PL_DESCRIPTION=$(sed -n 's/"//g;s/^description\s*=\s*\(.*\)$/\1/p' "$1")
18     PL_AUTHOR=$(sed -n 's/"//g;s/^author\s*=\s*\([^<]*\).*$/\1/p' "$1")
19     PL_MAIL=$(sed -n 's/"//g;s/^author\s*=[^<].*<\([^>]*\).*$/\1/p' "$1")
20   else
21     echo "Error: cannot find description file" >&2
22     exit 1
23   fi
24 }
27 TEMP=`getopt -o e:r: --long download,release:,email:,depends: -n 'dh-make-gosa' -- "$@"`
28 if [ $? != 0 ] ; then
29   echo "Error: cannot get command line information" >&2
30   exit 1
31 fi
33 eval set -- "$TEMP"
35 # Load command  line vars
36 RELEASE=trunk
37 DOWNLOAD=
38 DEPENDS=
39 DEST=
40 while true; do
41   case "$1" in
42     -e|--email) DEBMAIL=$2
43                 shift 2
44                 ;;
45     -r|--release)
46                 if [ "$2" != "trunk" ]; then
47                   RELEASE=tags/$2
48                 fi
49                 shift 2
50                 ;;
51     --depends)  DEPENDS="$2"
52                 shift 2
53                 ;;
54     --dest)     DEST=$2/
55                 shift 2
56                 ;;
57     --download) DOWNLOAD=yes
58                 shift 1
59                 ;;
60     --)         shift
61                 break
62                 ;;
63     *)          usage
64                 ;;
65   esac
66 done
68 [ $# -ne 1 ] && usage
69 file=$*
71 # Three possiblities
72 if [ -d "$file" ]; then
74   # It's a local directory
75   load_dsc $file/plugin.dsc
77   # Setup build environment
78   BUILD_PATH=${DEST}gosa-plugin-${PL_NAME}-${PL_VERSION}
79   if [ -d "$BUILD_PATH" ]; then
80     echo "Error: build path $BUILD_PATH already exists" >&2
81     exit 2
82   fi
83   cp -a "$PL_NAME" "$BUILD_PATH"
85 elif [ -f "$file" ]; then
87   # It's a compressed user contributed file
88   TMPDIR="/tmp/dh-make-gosa-$PPID"
89   if [ -d "/tmp/dh-make-gosa-$PPID"  ]; then
90     echo "Error: directory $TMPDIR exists" >&2
91     exit 4
92   fi
94   # Untar
95   mkdir -p "$TMPDIR"
96   tar --extract --directory "$TMPDIR" -fz "$file" &> /dev/null
97   if [ $? -ne 0 ]; then
98     echo "Error: cannot extract plugin file - invalid file format" >&2
99     exit 5
100   fi
102   # It's a local directory
103   load_dsc TMPDIR/*/plugin.dsc
105   # Setup build environment
106   BUILD_PATH=${DEST}gosa-plugin-${PL_NAME}-${PL_VERSION}
107   mv "$TMPDIR/*" "$BUILD_PATH"
109 else
111   echo "Error: cannot find plugin $file" >&2
112   exit 5
114 fi
117 PL_DEPENDS=$(echo $PL_DEPENDS$DEPENDS | sed 's/,\s*$//')
118 echo "Debian package summary ========================================"
119 echo "Plugin:       $PL_NAME"
120 echo "Version:      $PL_VERSION"
121 echo "Description:  $PL_DESCRIPTION"
122 echo "Depends:      $PL_DEPENDS"
123 echo "Author name:  $PL_AUTHOR"
124 echo "Author email: $PL_MAIL"
125 echo
126 read -s -n 1 -p "Do you want to continue? (y/n)" ans; echo
127 [ "$ans" != "y" ] && exit 0
129 pushd . &> /dev/null
131 cd "$BUILD_PATH"
133 # Use gosa-plugin skelleton
134 echo "Calling dh_make..."
135 echo | dh_make -e "$PL_MAIL" -c gpl -s -n -f gosa-plugin-${PL_NAME}-${PL_VERSION}.tar.gz &> /dev/null
136 if [ $? -ne 0 ]; then
137         echo "Failed to call dh_make - aborting!"
138         exit 1
139 fi
141 echo "Apdapting debian descriptive files..."
143 # Generate install file
144 for dir in admin personal addons; do
145         [ -d $dir ] && echo -e "$dir\t\t\t/usr/share/gosa/plugins" > debian/install
146 done
147 for dir in help/*; do
148         echo -e "$dir\t\t\t/usr/share/gosa/plugins/$PL_NAME" >> debian/install
149 done
150 for dir in $(ls -1 locale | grep -v "^en$" | grep -v "^messages.po$"); do
151         echo -e "locale/$dir\t\t\t/usr/share/gosa/locale/plugins/$PL_NAME" >> debian/install
152 done
154 # Generate dirs
155 echo "usr/share/gosa" > debian/dirs
157 # If we've a contrib directory include it to the docs
158 if [ -d contrib ]; then
159         echo "contrib /usr/share/doc/gosa-plugin-$PL_NAME" >> debian/install
160 fi
161 if [ -d html ]; then
162         for i in html/*; do
163                 echo "$i /usr/share/gosa/html/plugins/$PL_NAME" >> debian/install
164         done
165 fi
167 # Fix copyright
168 sed -i '/^#/d;/^.*likewise for another author.*$/d' debian/copyright
169 year=$(date +%Y)
170 sed -i "s/.Copyright (C) YYYY Name OfAuthor./Copyright (C) $year $PL_AUTHOR/g" debian/copyright
171 sed -i "s/.url:\/\/example.com./http:\/\/www.gosa-project.org/g" debian/copyright
172 sed -i "/.put author's name and email here.\
173 /d" debian/copyright
174 sed -i '/^Upstream/,/^$/d' debian/copyright
176 # Adapt control
177 sed -i 's/^Section: unknown/Section: web/g' debian/control
178 sed -i 's/^Architecture: any/Architecture: all/g' debian/control
179 sed -i 's/^Depends: .*$/Depends: gosa/g' debian/control
180 sed -i "s/^Description: .*$/Description: $PL_NAME plugin for GOsa/g" debian/control
181 sed -i "s/^ <.*$/ %DESCRIPTION%/g" debian/control
182 dsc=$(tempfile)
184 echo $PL_DESCRIPTION 
185 cat <<EOF
187 GOsa is a combination of system-administrator and end-user web
188 interface, designed to handle LDAP based setups.
189 EOF
190 }| fmt -suw79 | sed 's/^/ /g' > $dsc
191 sed -i "/%DESCRIPTION%/r $dsc" debian/control
192 sed -i "/%DESCRIPTION%/d" debian/control
193 rm $dsc
195 # Adapt README.debian
196 cat <<EOF > debian/README.Debian
197 README.Debian for GOsa $PL_NAME plugin $PL_VERSION
198 -------------------------------------------
200 Please read the main GOsa README.Debian file for more information.
202 ----
203 $PL_AUTHOR <$PL_MAIL>  Fri 02 Jun 2006 16:23:50 +0200
204 EOF
206 # Fix README
207 sed -i "s/Comments regarding the Package/After installing this plugin you may need to reload apache../g" debian/README
209 # Fix rules
210 cat <<EOF > debian/rules
211 #!/usr/bin/make -f
212 # -*- makefile -*-
213 # GOsa default plugin debhelper file.
214 # This file was originally written by Joey Hess and Craig Small.
215 # As a special exception, when this file is copied by dh-make into a
216 # dh-make output file, you may use that output file without restriction.
217 # This special exception was added by Craig Small in version 0.37 of dh-make.
219 # Uncomment this to turn on verbose mode.
220 #export DH_VERBOSE=1
222 configure: configure-stamp
223 configure-stamp:
224         dh_testdir
225         touch configure-stamp
228 build: build-stamp
230 build-stamp: configure-stamp 
231         dh_testdir
233         touch $@
235 clean:
236         dh_testdir
237         dh_testroot
238         rm -f build-stamp configure-stamp
239         dh_clean 
241 install: build
242         dh_testdir
243         dh_testroot
244         dh_clean -k 
245         dh_installdirs
247 # Build architecture-independent files here.
248 binary-indep: build install
249         dh_testdir
250         dh_testroot
251         dh_installchangelogs 
252         dh_installdocs
253         dh_installexamples
254         dh_install
255         dh_installman
256         dh_strip
257         dh_compress
258         dh_fixperms
259         dh_installdeb
260         dh_gencontrol
261         dh_md5sums
262         dh_builddeb
264 binary: binary-indep
265 .PHONY: build clean binary-indep binary install configure
266 EOF
268 # Adapt postinst/postrm
269 for file in postinst postrm; do
270 sed 's!#DEBHELPER#!#DEBHELPER#\
272 # Get apache versions running\
273 servers=""\
274 for srv in apache apache-ssl apache2; do\
275         if [ -x /usr/sbin/$srv ]; then\
276                 servers="$srv $servers"\
277         fi\
278 done\
280 # Update gosa\
281 /usr/sbin/update-gosa\
283 # Finally restart servers\
284 for server in $servers; do\
285         if [ -x /usr/sbin/invoke-rc.d ]; then\
286                 invoke-rc.d $server restart\
287         else\
288                 /etc/init.d/$server restart\
289         fi\
290 done\
292 !' debian/$file.ex > debian/$file
293 done
295 # Remove examples
296 rm debian/*ex debian/*EX &> /dev/null
298 popd &> /dev/null
300 echo "Done."